//  created:    2013/06/26
//  filename:   Loop.h
//
//  author:     Guillaume Sanahuja
//              Copyright Heudiasyc UMR UTC/CNRS 7253
//
//  version:    $Id: $
//
//
//
/*********************************************************************/

//on inclut le header de la classe
#include "Loop.h"
//on inclut les headers des classes seulement déclarées dans Loop.h (forward declaration)
#include "Measure.h"
#include "Plane.h"
#include <FrameworkManager.h>
#include <Tab.h>
#include <GridLayout.h>
#include <SpinBox.h>
#include <PushButton.h>
#include <DataPlot1D.h>
#include <DataPlot2D.h>
#include <cvmatrix.h>

#include <fstream>

//on utilise le namespace std, ce qui évite d'écrire par exemple std::string
using namespace std;
using namespace Kalman;
using namespace framework::core;
using namespace framework::gui;
using namespace framework::actuator;

//constructeur, on hérite de Thread
Loop::Loop(FrameworkManager* parent,string name,int priority): Thread(parent,name,priority)
{
   Tab *main_tab=new Tab(parent->GetTabWidget(),ObjectName());//onglet principal
        button_kill=new PushButton(main_tab->NewRow(),"kill");//bouton
        button_start_log=new PushButton(main_tab->NewRow(),"start_log");//bouton
        button_stop_log=new PushButton(main_tab->LastRowLastCol(),"stop_log");//bouton
        period=new SpinBox(main_tab->NewRow(),"period thread (ms):",10,1000,1);//période du Thread

    measure=new Measure(parent,"measure");//le sinus
    measure->UseDefaultPlot();//utilise le graphe par défaut du sinus

    plane=new Plane(parent,"plane");
    plane->UseDefaultPlot();//utilise le graphe par défaut du sinus

    //exemple de graphe
    //ce graphe pourrait être fait dans la fonction plane->UseDefaultPlot
    //il est ici pour montrer comment construire des graphes en dehors de l'objet plane
    Tab *graphe_tab=new Tab(parent->GetTabWidget(),"exemple de graphe");//onglet pour le graphe
        xy_plot=new DataPlot2D(graphe_tab->NewRow(),"xy","x",-2500,3000,"y",0,500);//definition du graphe et des echelles
            xy_plot->AddCurve(plane->Output()->Element(0),plane->Output()->Element(2));//la courbe, on utilise output(0,0) pour x et output(2,0) pour y (voir Plane.cpp)

    //on specifie les objets à enregistrer (logs)
    parent->AddDeviceToLog(measure);
    parent->AddDeviceToLog(plane);

    //on recupere la force comme dans l'exemple du kalman
    ifstream dataInput;
	string tmpStr;
    f= new KVector<double, 1, true>(NTRY);
	dataInput.open("./f.m",ifstream::in);

	if (dataInput.fail())
	{
		cout<<"Unable to open input file!"<<endl;
	}

	//Read the measures matrix. This matrix have been generated by the Matlab script <generation.m>
	dataInput>>tmpStr;
	dataInput>>tmpStr;
	dataInput>>(*f);

	if (dataInput.fail())
	{
		cout<<"IO error!"<<endl;
	}

	dataInput.close();
}

Loop::~Loop()
{

}

//la boucle du Thread
void Loop::Run(void)
{
    //permet d'avertir si l'on fait des changements du mode temps réél au mode normal
    WarnUponSwitches(true);

    //on démarre le Thread de mesure
    measure->Start();

    //on fixe la période du Thread
    SetPeriodMS(period->Value());

    //initialisation variable
    int index=2;
    float force=(*f)(1);

    while(1)
    {
        //on synchronise avec la période
        WaitPeriod();
        //si la valeur de la box a changé, on fixe la période du Thread
        if(period->ValueChanged()==true) SetPeriodMS(period->Value());

        //boutons
        if(button_kill->Clicked()==true) break;//on quitte la boucle
        if(button_start_log->Clicked()==true) getFrameworkManager()->StartLog();//enregistrement des données
        if(button_stop_log->Clicked()==true) getFrameworkManager()->StopLog();//fin d'enregistrement

        plane->Update(measure->Theta(),measure->R(),force);

        //normalement on utilise les résultats du filtre pour calculer la loi de commande
        //ici on utilise directement la valeur de la force du fichier
        force=(*f)(index);
        if(index<NTRY-1) index++;
    }

    WarnUponSwitches(false);
}
